#ifndef __LR_TIMER__
#define __LR_TIMER__

#include "timer.h"

class LRTimer
{
public:
	LRTimer() : last_queried_time(0) {}
	virtual ~LRTimer() {}

	// default implementation returns exact time
	virtual double get_time() { return ::get_time(); }

	double get_time_diff()
	{
		double t_old = last_queried_time;
		last_queried_time = get_time();
		return last_queried_time - t_old;
	}
	/*
	enum Type
	{
		MIN_ORACLE,
		MINMAX_ORACLE,
		CONTRACT,
	};
	virtual void log_event(Type type, int param_num, int* params) {}
	*/

private:
	double last_queried_time;
};


#endif
